Subject: Re: [PATCH v3 04/10] submodule--helper clone: check for configured submodules using helper

From: Junio C Hamano <[email-masked]>
Date: Tue, 14 Mar 2017 13:25:08 -0700

Stefan Beller <[email-masked]> writes:

>> I am wondering what was meant by the comment "We must not fall back to..."
>> that is being removed---is that because sub->url can come from .gitmodules
>> that is in-tree, not from .git/config?
>
> Yes. We want to check for the submodule being "initialized", i.e.
> having a url in .git/config. (and the struct submodule reads in both .git/config
> and .gitmodules and overlays them with a given precedence order)

OK, thanks.

I agree that the current code happens to be OK but the arrangement
looks rather brittle to me.  It seems the code liberally call
gitmodules_config() without making sure it is early enough to do so
(iow, git_config() for submodule-related stuff has not been done and
will be done before the values read there are the ones that are
used).